package music;
import org.jfugue.player.Player;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.Random;

import org.jfugue.midi.MidiFileManager;
import org.jfugue.pattern.Pattern;
import org.jfugue.theory.Chord;
import org.jfugue.theory.ChordProgression;
import org.jfugue.theory.Note;
import org.staccato.ReplacementMapPreprocessor;

import javax.swing.*;

import java.lang.Math;

import java.util.logging.Logger;

/*
 * Inserire dei suoni e combinarli con l'algoritmo.
 * 
 * 
 * Cambiare i valori del julia set -> saltare le ascisse e leggerle ogni 10 per esempio
 * 
 * 
 * Polmoni
 * 
 * Costa Granbretgna
 * 
 * Polvere come x e y = random 
 * 
 * Foglia di platano
 * 
 * Felce fratta,e IFS 
 * 
 * 
 * 
 * */

public class MyMusic {

	public static final int WIDTH=800;
	public static final int HEIGHT=600;
	public static final int ITERATIONS=4;
	public static final int SCALE=200;
	public static int MODULO = 12;
	public static final int TEMPI = 16;
	static ArrayList<String> punti = new ArrayList<String>();
	public static final String FRACTAL = "julia";
	// FRACTAL = mandelbrot / koch / julia / fibonacci / tree / cantor
	@SuppressWarnings("static-access")
	public static void main(String[] args) throws IOException {
		/*
		 * 
		 * Mandelbrot set
		 * 
		 * 
		 */
		int JUMP = 20;
		int len = 20000;
		System.out.println("Start "+ FRACTAL + " song");
		if(FRACTAL.compareTo("mandelbrot")==0) {
			JUMP = 20;
			len = 20000;
			for(int x=0;x<WIDTH;x++){
				for(int y=0;y<HEIGHT;y++) {
					ArrayList<String> newpoints = calculatePoint((x-WIDTH/2f)/SCALE,(y-HEIGHT/2f)/SCALE);
					if(newpoints != null) {
						punti.addAll(newpoints);
					}else {
						break;
					}
						
				}
			}
		}else if(FRACTAL.compareTo("koch")==0) {
		/*
		 * 
		 * Koch curve
		 * 
		 */ 
			
			BasicBitmapStorage bbs = new BasicBitmapStorage(WIDTH, HEIGHT);
			bbs.fill(Color.white);
			punti.addAll(bbs.koch(100.0, 100.0, 400.0, 400.0, ITERATIONS));
			
			len = punti.size(); 
			JUMP  = 2;
			
		
		}else if (FRACTAL.compareTo("julia")==0) {
		
		
		/*
		 * 
		 * Julia set
		 * 
		 */
			
			int maxIter= 100;
			double zoom = 1;
			double cX, cY;
			
			int w =800;
	        int h =600;
	        BufferedImage image = new BufferedImage(w, h,
	                BufferedImage.TYPE_INT_RGB);
	 
	        cX = -0.7;
	        cY = 0.27015;
	        double moveX = 0, moveY = 0;
	        double zx, zy;
	 
	        for (int x = 0; x < w; x++) {
	            for (int y = 0; y < h; y++) {
	                zx = 1.5 * (x - w / 2) / (0.5 * zoom * w) + moveX;
	                zy = (y - h / 2) / (0.5 * zoom * h) + moveY;
	                float i = maxIter;
	                while (zx * zx + zy * zy < 4 && i > 0) {
	                    double tmp = zx * zx - zy * zy + cX;
	                    zy = 2.0 * zx * zy + cY;
	                    zx = tmp;
	                    i--;
	                    punti.add(zx+"_"+zy);
	                }

		            System.out.println("Finito con "+ x +  " - "+ y);
	            }
	        } 
	        len = 10000;
	        JUMP =67;
		}else if(FRACTAL.compareTo("fibonacci")==0) {
			punti.addAll(pointWordFractal(20,20,1,0,20));
			
			len = punti.size();
			JUMP=2;
		}else if (FRACTAL.compareTo("tree")==0) {
			pointTree(800, 1000, -90, 13);
			len = punti.size();
			//-90 _> jump=27
			JUMP =27;
		}else if(FRACTAL.compareTo("cantor")==0) {
			pointCantor(0, 1000, 1);			
			MODULO=12;
			JUMP=5;
		}
		
		
		System.out.println("\nPunti array lenght: "+punti.size());
	    System.out.println("Inizio calcolo note e durata");
	    String note = "";
	    
	    
	    for (int i = 1;i<len-JUMP;i=i+JUMP) {
	    	String[] p = punti.get(i).split("_");
	    	float x = Float.parseFloat(p[0]);
	    	float y = Float.parseFloat(p[1]);
	    	int nota = abs((int) (x%MODULO));
	    	int ottava =abs((int)y%10);
	    	
	    	System.out.println("Nota :"+nota+" "+ottava);
	    	
	    	String[] p1 = punti.get(i+JUMP).split("_");
	    	float x1 = Float.parseFloat(p1[0]);
	    	float y1 = Float.parseFloat(p1[1]);
	    	
	    	float distanza = (float) Math.sqrt(Math.pow(Math.abs(x1-x), 2)+Math.pow(Math.abs(y1-y), 2));
	    	
	    	System.out.println("Distanza: "+ distanza);
	    	
	    	//calcolo il modulo 16 della distanza, cos al massimo ho delle semicrome -> 0 sta per 1
	    	
	    	int durata = (int) (distanza%TEMPI);
	    	System.out.println("Durata: "+ durata+"/16");
	    	String nota_str = makeNote(nota)+ottava+makeDuration(durata);
	    	
	    	System.out.println("Nota finale: "+nota_str);
	    	
	    	
	    	
	    	if(i==0) {
	    		note = nota_str;
	    	} else {
	    		note += " "+nota_str;
	    	}
	    	
	    	System.out.println("-------------------------");
	    	
	    	
	    }
	    
	    //System.out.println("Stringa note:\n"+ note);
	    
	    
	    Player player = new Player();
		Pattern axiom = new Pattern("T110 " + "V0 I[Piano] "+note);
		MidiFileManager mfm = new MidiFileManager();
	    File f = new File(FRACTAL+"_v1.midi");
	    mfm.save(player.getSequence(axiom), f);
	    
	    player.play(axiom);	    
	    
	    
	    
	    System.out.println("************************End**************************");
	}
	
	public static String makeNote(int nota) {
		switch(nota) {
		case 0:
			return "C";
		case 1:
			return "C#";
		case 2:
			return "D";
		case 3:
			return "D#";
		case 4:
			return "E";
		case 5:
			return "F";
		case 6:
			return "F#";
		case 7:
			return "G";
		case 8:
			return "G#";
		case 9:
			return "A";
		case 10:
			return "A#";
		case 11:
			return "B";		
		}
		return "";
	}
		
		public static String makeDuration(int nota) {
			switch(nota) {
			case 0:
				return "w";
			case 1:
				return "s";
			case 2:
				return "i";
			case 3:
				return "sss";
			case 4:
				return "q";
			case 5:
				return "sssss";
			case 6:
				return "iii";
			case 7:
				return "s7";
			case 8:
				return "h";
			case 9:
				return "s9";
			case 10:
				return "i5";
			case 11:
				return "s11";
			case 12:
				return "q3";	
			case 13:
				return "s13";
			case 14:
				return "i7";
			case 15:
				return "s15";
			}
			
		
		return "";
	}
	
	public static int abs(int a) {
		if(a>=0)
			return a;
		return -a;
	}

	public static ArrayList<String> calculatePoint(float x, float y) {
		float cx=x;
		float cy=y;
		int i=0;
		ArrayList<String> array = new ArrayList<String>();
		
		for(; i<ITERATIONS;i++) {
			float nx= x*x -y*y+cx;
			float ny = 2*x*y+cy;
			x=nx;
			y=ny;
			
			if(x*x +y*y < 4) {
				array.add(new String(x+"_"+y));
				//System.out.print("\nadded "+x +" "+y);
			};
			
		}
		if(i==ITERATIONS) {
		return array;
		}
		return array;
	}
	
	public static String wordFractal(int n) {
        if (n < 2)
            return n == 1 ? "1" : "";
 
        // we should really reserve fib n space here
        StringBuilder f1 = new StringBuilder("1");
        StringBuilder f2 = new StringBuilder("0");
 
        for (n = n - 2; n > 0; n--) {
            String tmp = f2.toString();
            f2.append(f1);
 
            f1.setLength(0);
            f1.append(tmp);
        }
 
        return f2.toString();
    }
	
	public static ArrayList<String> pointWordFractal(int x, int y, int dx, int dy, int N) {
		String word = wordFractal(N);
		ArrayList<String> lista = new ArrayList<String>();
        for (int n = 0; n < word.length(); n++) {
            
            lista.add(x+"_"+y);
            x += dx;
            y += dy;
            if (word.charAt(n) == '0') {
                int tx = dx;
                dx = (n % 2 == 0) ? -dy : dy;
                dy = (n % 2 == 0) ? tx : -tx;
            }
        }
        return lista;
    }
	
	public static void pointTree(int x1, int y1, double angle, int depth) {
        if (depth == 0) return;
        int x2 = x1 + (int) (Math.cos(Math.toRadians(angle)) * depth * 10.0);
        int y2 = y1 + (int) (Math.sin(Math.toRadians(angle)) * depth * 10.0);
        punti.add(x2+"_"+y2);
        pointTree( x2, y2, angle - 20, depth - 1);
        pointTree( x2, y2, angle + 20, depth - 1);
        return;
        
    }
	
	public static void pointCantor(int start, int depth, int index) {
		int seg = depth/3; 
		
        if (seg == 0) return;
        for (int i = index; i < HEIGHT; i++) {
            for (int j = start; j < start + seg; j++) {
            	Random r = new Random();
            	r.setSeed(3);
            	int low = 0;
            	int high = 11;
            	int result = r.nextInt(high-low) + low;
            	punti.add(j+"_"+result);                
            }
        }
        pointCantor(start, seg, index + 1);
        pointCantor(start + seg * 2, seg, index + 1);
		
		return;
	}
	
	
	
}
